import cgi

from google.appengine.api import users
from google.appengine.ext import webapp
from google.appengine.ext.webapp.util import run_wsgi_app
from google.appengine.ext import db
from google.appengine.ext.db import Key

class Rdf(db.Model):
    content = db.TextProperty()
    date = db.DateTimeProperty(auto_now_add=True)

class MainPage(webapp.RequestHandler):
    def get(self):

        rdfs = db.GqlQuery("SELECT * FROM Rdf ORDER BY date DESC LIMIT 10")

        for rdf in rdfs:
            self.response.out.write('(%s):<br/>' %rdf.key())
            self.response.out.write('%s<br/>' %
                                    cgi.escape(rdf.content))

        # Write the submission form and the footer of the page
        self.response.out.write("""
              <form action="/save" method="post">
                <div><textarea name="content" rows="3" cols="60"></textarea></div>
                <div><input type="submit" value="Submit text"></div>
              </form>
            </body>
          </html>""")

class SaveRDF(webapp.RequestHandler):
    def post(self):
        rdf = Rdf()
        rdf.content = self.request.get('content')
        rdf.put()
        self.response.out.write(str(rdf.key()))

class Browse(webapp.RequestHandler):
    def get(self, _key_):
        rdf = db.GqlQuery("SELECT FROM Rdf WHERE __key__ = :1", Key(_key_))
        self.response.out.write('%s' %rdf.get().content)

application = webapp.WSGIApplication(
                                     [('/', MainPage),
                                      ('/save', SaveRDF),
                                      ('/rdf/(.*)', Browse)],
                                     debug=True)

def main():
    run_wsgi_app(application)

if __name__ == "__main__":
    main()
